diff --git a/kernel/sched_features.h b/kernel/sched_features.h
index 68e69ac..b0eda12 100644
--- a/kernel/sched_features.h
+++ b/kernel/sched_features.h
@@ -64,3 +64,23 @@ SCHED_FEAT(OWNER_SPIN, 1)
  * Decrement CPU power based on irq activity
  */
 SCHED_FEAT(NONIRQ_POWER, 1)
+
+#ifdef CONFIG_SCHED_FAIR_HTFS
+
+/*
+ * Try to pull all sched entities in the hierarchy on the interactive runqueues
+ * on wakeup
+ */
+SCHED_FEAT(WAKEUP_PULL_INTERQ, 1)
+
+/*
+ * Automatic changing of timeslices
+ */
+SCHED_FEAT(DYNAMIC_TIMESLICE, 1)
+
+/*
+ * Tries to continue running current task (in case a lock is freed on another processor
+ */
+SCHED_FEAT(PROB_RERUN, 1)
+
+#endif
diff --git a/kernel/sysctl.c b/kernel/sysctl.c
index 443fd20..7ff58a1 100644
--- a/kernel/sysctl.c
+++ b/kernel/sysctl.c
@@ -256,6 +256,7 @@ static struct ctl_table root_table[] = {
 };
 
 #ifdef CONFIG_SCHED_DEBUG
+#ifdef CONFIG_SCHED_FAIR_CFS
 static int min_sched_granularity_ns = 100000;		/* 100 usecs */
 static int max_sched_granularity_ns = NSEC_PER_SEC;	/* 1 second */
 static int min_wakeup_granularity_ns;			/* 0 usecs */
@@ -263,6 +264,7 @@ static int max_wakeup_granularity_ns = NSEC_PER_SEC;	/* 1 second */
 static int min_sched_tunable_scaling = SCHED_TUNABLESCALING_NONE;
 static int max_sched_tunable_scaling = SCHED_TUNABLESCALING_END-1;
 #endif
+#endif
 
 #ifdef CONFIG_COMPACTION
 static int min_extfrag_threshold;
@@ -270,6 +272,7 @@ static int max_extfrag_threshold = 1000;
 #endif
 
 static struct ctl_table kern_table[] = {
+#ifdef CONFIG_SCHED_FAIR_CFS
 	{
 		.procname	= "sched_child_runs_first",
 		.data		= &sysctl_sched_child_runs_first,
@@ -352,6 +355,29 @@ static struct ctl_table kern_table[] = {
 		.extra2		= &one,
 	},
 #endif
+#elif CONFIG_SCHED_FAIR_HTFS
+	{
+		.procname	= "sched_inter_timeslice_shift",
+		.data		= &sysctl_sched_inter_slice_shift,
+		.maxlen		= sizeof(unsigned int),
+		.mode		= 0644,
+		.proc_handler	= sched_proc_update_handler,
+	},
+	{
+		.procname	= "sched_inter_latency",
+		.data		= &sysctl_sched_inter_latency,
+		.maxlen		= sizeof(u64),
+		.mode		= 0644,
+		.proc_handler	= proc_dointvec,
+	},
+	{
+		.procname	= "sched_timeslice_max_shift",
+		.data		= &sysctl_sched_slice_max_shift,
+		.maxlen		= sizeof(unsigned int),
+		.mode		= 0644,
+		.proc_handler	= proc_dointvec,
+	},
+#endif
 	{
 		.procname	= "sched_rt_period_us",
 		.data		= &sysctl_sched_rt_period,
@@ -366,6 +392,7 @@ static struct ctl_table kern_table[] = {
 		.mode		= 0644,
 		.proc_handler	= sched_rt_handler,
 	},
+#ifdef CONFIG_SCHED_FAIR_CFS
 	{
 		.procname	= "sched_compat_yield",
 		.data		= &sysctl_sched_compat_yield,
@@ -373,6 +400,7 @@ static struct ctl_table kern_table[] = {
 		.mode		= 0644,
 		.proc_handler	= proc_dointvec,
 	},
+#endif
 #ifdef CONFIG_SCHED_AUTOGROUP
 	{
 		.procname	= "sched_autogroup_enabled",
